// POV Color samples

#include "Colors.inc"

global_settings {assumed_gamma 1}

default {
   finish {
      phong 1 phong_size 100
      ambient .15
      diffuse .7
   }
}

#declare nCols = 12;
#declare nRows = 12;
#declare Radius = 3;
#declare Space = 1/8;
#declare CenterZ = 0;

#declare W = 2 * nCols * Radius + Space * nCols;
#declare H = 2 * nRows * Radius + Space * nRows;

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`

/*
#declare SceneW = (nCols * 2 * Radius) + ((nCols - 1) * Space) + Space;
camera {
  orthographic
  location -1E6*z
  right x*SceneW
  up    y*SceneW*image_height/image_width
}  
*/

#declare Offset = 1.5;  //Offset for shadow
#declare SceneW = (nCols * 2 * Radius) + ((nCols - 1) * Space) + Space + Offset;
camera {
  orthographic
  location <Offset/2, -Offset/2, -1E6>
  right x*SceneW
  up    y*SceneW*image_height/image_width
}  

light_source {<-500, 500, -1500> color White}

plane {
  z, Radius + 0.1
  pigment {rgb .95}
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`

#include "POV Colors.inc"

#declare i = 1;
#if(clock_on) #declare i = clock; #end

#declare k = ((i - 1) * nCols * nRows);
#local i = 0;
#while (i <= nRows - 1)
  #local j = 0;
  #while (j <= nCols - 1)
    sphere {
      #local x_ = (Space/2 + Radius) + j * (2*Radius + Space);
      #local y_ = (Space/2 + Radius) + i * (2*Radius + Space);
      #if (k < nColors)
        #local C = Color[k]
      #else
        #local C = rgbf 1;
      #end
      <x_, -y_, CenterZ>, Radius pigment {C}
      translate <-W/2, H/2, 0>  // Center on origin
    }
    #local j = j + 1;
    #declare k = k + 1;
  #end
  #local i = i + 1;
#end





